﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Schulprojekt
{
    public partial class Ingame : Form
    {
        variablen v = new variablen();
        Listener l = new Listener();

        public Ingame()
        {
            InitializeComponent();
            //add boxes
            v.boxlist.Add(box);
            v.boxlist.Add(box2);

            //add spikes
            v.spikelist.Add(spike1);

            //set player

            v.player = player;

        }

        private void Ingame_Load(object sender, EventArgs e)
        {

        }

       


        private void Ingame_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
            {
                this.Close();
            }
                if (e.KeyCode == Keys.D)
                {
                v.right = true;
            }

                if (e.KeyCode == Keys.A)
                {
                v.left = true;
            }
            
            

            if (e.KeyCode == Keys.Space && v.jump != true && v.sidecollision == false)
            {
                v.space = true;
                if (v.botcollision != true)
                {
                    v.topcollision = false;
                    v.collision = false;
                    v.jump = true;
                    v.force = v.g;
                }
                
            }
        }

        private void Ingame_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.D)
            {
                v.right = false;
            }

            if (e.KeyCode == Keys.A)
            {
                v.left = false;
            }
            if (e.KeyCode == Keys.Space)
            {
                v.space = false;
            }
        }

        private void t1_Tick_1(object sender, EventArgs e)
        {
            //bot
            for (int i = 0; i < v.boxlist.Count; i++)
            {
                if (!(player.Top >= v.boxlist[i].Top + v.boxlist[i].Height && player.Left + player.Width - 1 >= v.boxlist[i].Left && player.Left + player.Width + 5 <= v.boxlist[i].Left + v.boxlist[i].Width + player.Width))
                {
                    v.botcollision = false;

                }
            }

            for (int i= 0; i< v.boxlist.Count;i++)
            {
                if (player.Top >= v.boxlist[i].Top + v.boxlist[i].Height && player.Left + player.Width - 1 >= v.boxlist[i].Left && player.Left + player.Width + 5 <= v.boxlist[i].Left + v.boxlist[i].Width + player.Width)
                {
                    v.topcollision = false;
                    v.sidecollision = false;
                    v.botcollision = true;
                    if (v.space == true && v.jump == false)
                    {
                        v.jump = true;
                        player.Top = v.boxlist[i].Bottom;
                    }

                }
            }

            //collision box
            if (v.collidedBox != null)
            {
                
                // top
                if (v.collision == true && v.botcollision == false && player.Left + player.Width - 1 >= v.collidedBox.Left && player.Left + player.Width + 5 <= v.collidedBox.Left + v.collidedBox.Width + player.Width && player.Top + player.Height >= v.collidedBox.Top && player.Top <= v.collidedBox.Top)
                { 
                    player.Top = v.collidedBox.Top - player.Height + 1;
                    v.force = 0;
                    v.topcollision = true;
                    v.sidecollision = false;
                    v.botcollision = false;
                }
                

                //side

                if (player.Right > v.collidedBox.Left && player.Left < v.collidedBox.Right - player.Width / 2 && player.Bottom > v.collidedBox.Top +2)
                {
                    v.right = false;
                    player.Top -= v.force;
                    v.force -= 1;
                    v.jump = false;
                    v.sidecollision = true;
                }

                if (player.Left < v.collidedBox.Right && player.Right > v.collidedBox.Left + player.Width / 2 && player.Bottom > v.collidedBox.Top+2)
                {
                    v.left = false;
                    player.Top -= v.force;
                    v.force -= 1;
                    v.jump = false;
                    v.sidecollision = true;
                }
            }

            //colission spike
            if (v.collidedspike != null)
            {
                if (v.collision == true)
                {
                    player.Top = Respawn.Bottom + player.Height;
                    player.Left = Respawn.Left;
                    v.left = false;
                    v.right = false;
                    MessageBox.Show("You Died");
                }
            }

            //walk right
            if (v.right == true)
            {
                player.Left += 5;
            }

            //walk left
            if (v.left == true)
            {
                player.Left -= 5;
            }

            //jump
            if (v.jump == true && v.botcollision == false)
            {
                    player.Top -= v.force;
                    v.force -= 1;
                

            }

            if (player.Top + player.Height >= screen.Height)
            {
                player.Top = screen.Height - player.Height;
                v.jump = false;
                v.collision = false;
                v.sidecollision = false;

            }
            else if(v.topcollision == false)
            {
                player.Top += 5;
            }
           

            
        }

        private void screen_Paint(object sender, PaintEventArgs e)
        {
            IEnumerable<Control> boxCollection = v.boxlist.Where(control => control.GetType() == typeof(PictureBox));
            bool isColliding = boxCollection.Any(PictureBox => v.player.Bounds.IntersectsWith(PictureBox.Bounds));
            if (isColliding)
            {
                v.collidedBox = boxCollection.FirstOrDefault(PictureBox => v.player.Bounds.IntersectsWith(PictureBox.Bounds));
                if (v.collidedBox != null)
                {
                    if (v.player.Bounds.IntersectsWith(v.collidedBox.Bounds))

                    {
                        // TODO: Implement logic to set player on top of the box. (Stop falling)
                        v.collision = true;
                        v.jump = false;

                    }
                    else
                    {
                        v.collision = false;
                        v.topcollision = false;

                    }
                }
                else
                {
                    v.collision = false;
                    v.topcollision = false;
                }
            }
            else
            {
                v.collidedBox = null;
                v.topcollision = false;
            }

            IEnumerable<Control> spikeCollection = v.spikelist.Where(control => control.GetType() == typeof(PictureBox));
            bool isspikeColliding = spikeCollection.Any(PictureBox => v.player.Bounds.IntersectsWith(PictureBox.Bounds));
            if (isspikeColliding)
            {
                v.collidedspike = spikeCollection.FirstOrDefault(PictureBox => v.player.Bounds.IntersectsWith(PictureBox.Bounds));
                if (v.collidedspike != null)
                {
                    if (v.player.Bounds.IntersectsWith(v.collidedspike.Bounds))

                    {
                        // TODO: Implement logic to set player on top of the box. (Stop falling)
                        v.collision = true;
                        v.jump = false;
                    }
                    else
                    {
                        v.collision = false;
                        v.topcollision = false;

                    }
                }
                else
                {
                    v.collision = false;
                }
            }
            else
            {
                v.collidedspike = null;
            }

        }
    }
}
